﻿namespace FibonacciSequence {
    class Program {

		public static IEnumerable<ulong> CorrectedFibonacciSequenceV2(int n) {
			if (n < 0)
				throw new ArgumentOutOfRangeException(nameof(n), "The number of elements in the Fibonacci sequence cannot be negative.");

			if (n > 94)
				throw new ArgumentOutOfRangeException(nameof(n), "Too big Fibonacci sequence. Elements would overflow.");

			return iteratorImplementation(n);

			static IEnumerable<ulong> iteratorImplementation(int n) {
				if (n == 0)
					yield break;

				yield return 0;

				if (n == 1)
					yield break;

				yield return 1;

				if (n == 2)
					yield break;

				ulong a = 0;
				ulong b = 1;

				for (uint i = 2; i < n; i++) {
					ulong s = a + b;
					yield return s;
					a = b;
					b = s;
				}
			}

		}
    }
}